/* util.h
 *
 * prototype the function in util.c
 *
 * (c) NLnet Labs, 2004
 *
 * See the file LICENSE for the license
 *
 */

/*
#define DEBUGMEM 1
*/
 
#ifdef DEBUGMEM
#define xmalloc(size) xmalloc_ex(size, __FILE__, __LINE__)
#define xrealloc(x, y) xrealloc_ex(x, y, __FILE__, __LINE__)
#define xfree(x) xfree_ex(x, __FILE__, __LINE__)
#define xstrdup(string) xstrdup_ex(string, __FILE__, __LINE__)
#define xstrndup(string, size) xstrdup_ex(string, size, __FILE__, __LINE__)
#else
void * xmalloc(size_t);
void * xrealloc(void *, size_t);
void xfree(void *);
char * xstrdup(const char*);
char * xstrndup(const char*, size_t);
#endif

void show_mem(void);
char * str_cat(char*, char*);
